%% If this file is name load_sicstus_debug_TEMPLATE.pl then you should NOT load it!
%% otherwise it is supposed to load the sicstus_debug stuff if consulted.
%% It might need  modified slightly, see !! below
/* I.e., in your .sicstusrc you would typically put
:-['/wherever/this/file/resides/load_sicstus_debug']
*/

%% !! Load architecture dependant object code. DO THIS FIRST!
%% There are no standard way of accessing the architecture
%% Suppose there is an environment variable ARCH containing, e.g., 'sparc4'
%% then you could do
%% :- (current_predicate(_, buffer_mode:_) -> true; load('$ARCH/buffer_mode')).
%% For the simple case where you have only a single architecture you
%% could just compile architecture_dependant/buffer_mode.c in place
%% and do
%% :- (current_predicate(_, buffer_mode:_) -> true; load('architecture_dependant/buffer_mode')).
%%
%%
%% The following assumes that /bin/uname -m returns eg 'sparc4m'
%% Note that on HP-UX it will return something like 9000/715
%%

%% Instead of use_module so that we don't affect the imported names.
:- ensure_loaded(library(system)).
:- ensure_loaded(library(lists)).

:- ( current_predicate(_, buffer_mode:_) ->
       true
   ; otherwise ->
       
       %% Make Machine become eg "sun4m", make 9000/715 become 9000_715 (HP)
      system:popen('/bin/uname -m | tr "/" "_"',read, Stream),
      findall(C, ( repeat,
                      get0(Stream, C),
                      ((C == -1; C = 10; C = 13) -> !,fail; true)
                 ), Machine),
      close(Stream),

      %% make Path become eg sun4m/buffer_mode.ql
      lists:append(Machine, "/buffer_mode.ql", PathChars),
      atom_chars(Path, PathChars),
      ( ( predicate_property(load_foreign_resource(_),_),
          system:file_exists(Path, read) ) ->
          load(Path)
      ; otherwise ->
          write(user_error, '\n{ *** Could not load buffer_mode, output might be slower     *** }'),
          write(user_error, '\n{ *** This is not normally a big problem but should be fixed *** }\n'),
          flush_output(user_error)
      )
   ).

%% **** THE FOLLOWING MUST BE DONE AFTER LOADING buffer_mode ****
%% load unless already loaded
%% current_module is not a good test!
%% Why not use ensure_loaded?
%% Because it will (sometimes) consult instead of load!
:- (current_predicate(_, emacs:_) -> true ; load('emacs-interface')).
:- (current_predicate(_, source_debug:_) -> true; load('source-debug')).
